import { renderless, api } from "@xmweb-ui/vue-renderless/cascader/vue";
import { defineComponent, props, setup as _setup } from "@xmweb-ui/vue-common";
import Clickoutside from "@xmweb-ui/vue-renderless/common/deps/clickoutside";
import Input from "@xmweb-ui/vue-input";
import Tag from "@xmweb-ui/vue-tag";
import Scrollbar from "@xmweb-ui/vue-scrollbar";
import CascaderPanel from "@xmweb-ui/vue-cascader-panel";
import FilterBox from "@xmweb-ui/vue-filter-box";
import Tooltip from "@xmweb-ui/vue-tooltip";
import { iconClose, iconChevronDown, iconChevronUp, iconYes } from "@xmweb-ui/vue-icon";
import { resolveComponent, resolveDirective, withDirectives, openBlock, createElementBlock, normalizeClass, createBlock, withModifiers, createCommentVNode, createElementVNode, withCtx, resolveDynamicComponent, createTextVNode, toDisplayString, Fragment, renderList, withKeys, vModelText, createVNode, Transition, vShow, createSlots, renderSlot } from "vue";
function _createForOfIteratorHelperLoose(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
  if (it)
    return (it = it.call(o)).next.bind(it);
  if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
    if (it)
      o = it;
    var i = 0;
    return function() {
      if (i >= o.length)
        return { done: true };
      return { done: false, value: o[i++] };
    };
  }
  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o)
    return;
  if (typeof o === "string")
    return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor)
    n = o.constructor.name;
  if (n === "Map" || n === "Set")
    return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
    return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length)
    len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++)
    arr2[i] = arr[i];
  return arr2;
}
var _export_sfc = function _export_sfc2(sfc, props) {
  var target = sfc.__vccOpts || sfc;
  for (var _iterator = _createForOfIteratorHelperLoose(props), _step; !(_step = _iterator()).done; ) {
    var _step$value = _step.value, key = _step$value[0], val = _step$value[1];
    target[key] = val;
  }
  return target;
};

var _sfc_main = defineComponent({
  props: [].concat(props, ["modelValue", "options", "props", "size", "placeholder", "disabled", "clearable", "filterable", "filterMethod", "separator", "showAllLevels", "collapseTags", "debounce", "beforeFilter", "popperClass", "placement", "popperOptions", "visibleArrow", "offset", "boundariesPadding", "arrowOffset", "popperAppendToBody", "autoSize", "displayOnly", "shape", "label", "tip", "hoverExpand"]),
  emits: ["update:modelValue", "change", "visible-change", "focus", "blur", "expand-change", "active-item-change", "remove-tag", "created"],
  directives: {
    Clickoutside
  },
  provide: function provide() {
    return {
      cascaderRoot: this
    };
  },
  components: {
    XmInput: Input,
    XmTag: Tag,
    XmScrollbar: Scrollbar,
    XmFilterBox: FilterBox,
    XmCascaderPanel: CascaderPanel,
    IconClose: iconClose(),
    IconChevronDown: iconChevronDown(),
    IconChevronUp: iconChevronUp(),
    IconYes: iconYes(),
    XmTooltip: Tooltip
  },
  setup: function setup(props2, context) {
    return _setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var _hoisted_1 = {
  ref: "reference",
  class: "xm-cascader-content"
};
var _hoisted_2 = ["placeholder"];
var _hoisted_3 = ["onClick"];
var _hoisted_4 = {
  class: "xm-cascader__empty-text"
};
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_xm_filter_box = resolveComponent("xm-filter-box");
  var _component_icon_close = resolveComponent("icon-close");
  var _component_xm_input = resolveComponent("xm-input");
  var _component_xm_tag = resolveComponent("xm-tag");
  var _component_xm_tooltip = resolveComponent("xm-tooltip");
  var _component_xm_cascader_panel = resolveComponent("xm-cascader-panel");
  var _component_icon_yes = resolveComponent("icon-yes");
  var _component_xm_scrollbar = resolveComponent("xm-scrollbar");
  var _directive_clickoutside = resolveDirective("clickoutside");
  return withDirectives((openBlock(), createElementBlock(
    "div",
    {
      ref: "reference",
      class: normalizeClass(["xm-cascader", _ctx.state.realSize && "xm-cascader--" + _ctx.state.realSize, {
        "is-disabled": _ctx.state.isDisabled
      }, {
        "xm-cascader-multiple": _ctx.state.multiple
      }, {
        "is-display-only": _ctx.state.isDisplayOnly
      }, {
        "show-auto-width": _ctx.state.showAutoWidth
      }, {
        "is-hover-expand": _ctx.hoverExpand
      }]),
      onMouseenter: _cache[10] || (_cache[10] = function($event) {
        return _ctx.state.inputHover = true;
      }),
      onMouseleave: _cache[11] || (_cache[11] = function($event) {
        return _ctx.state.inputHover = false;
      }),
      onClick: _cache[12] || (_cache[12] = function() {
        return _ctx.toggleDropDownVisible(_ctx.state.readonly ? void 0 : true);
      }),
      onKeydown: _cache[13] || (_cache[13] = function() {
        return _ctx.handleKeyDown && _ctx.handleKeyDown.apply(_ctx, arguments);
      })
    },
    [_ctx.shape === "filter" ? (openBlock(), createBlock(_component_xm_filter_box, {
      key: 0,
      onClick: _cache[0] || (_cache[0] = withModifiers(function($event) {
        return _ctx.toggleDropDownVisible();
      }, ["stop"])),
      "show-close": _ctx.clearable,
      disabled: _ctx.state.isDisabled,
      label: _ctx.label,
      tip: _ctx.tip,
      value: _ctx.state.multiple ? _ctx.state.presentTags.map(function(item) {
        return item.text;
      }).join("; ") : _ctx.state.inputValue,
      "drop-down-visible": _ctx.state.dropDownVisible
    }, null, 8, ["show-close", "disabled", "label", "tip", "value", "drop-down-visible"])) : createCommentVNode("v-if", true), createElementVNode(
      "div",
      _hoisted_1,
      [_ctx.shape !== "filter" ? (openBlock(), createBlock(_component_xm_input, {
        key: 0,
        ref: "input",
        "model-value": _ctx.state.multiple ? _ctx.state.presentText : _ctx.state.inputValue,
        size: _ctx.state.realSize,
        placeholder: _ctx.state.placeholder,
        readonly: _ctx.state.readonly,
        disabled: _ctx.state.isDisabled,
        "display-only": _ctx.displayOnly,
        "display-only-content": _ctx.state.multiple ? _ctx.state.presentTags.map(function(item) {
          return item.text;
        }).join("; ") : "",
        "validate-event": false,
        class: normalizeClass({
          "is-focus": _ctx.state.dropDownVisible
        }),
        onFocus: _ctx.handleFocus,
        onBlur: _ctx.handleBlur,
        "onUpdate:modelValue": _ctx.handleInput
      }, {
        suffix: withCtx(function() {
          return [_ctx.state.clearBtnVisible ? (openBlock(), createBlock(_component_icon_close, {
            key: "clear",
            class: normalizeClass(["xm-input__icon", "xm-input__icon-close"]),
            onClick: withModifiers(_ctx.handleClear, ["stop"])
          }, null, 8, ["onClick"])) : (openBlock(), createBlock(resolveDynamicComponent(_ctx.state.dropDownVisible ? "icon-chevron-up" : "icon-chevron-down"), {
            key: "arrow-down",
            class: normalizeClass(["xm-input__icon", _ctx.state.dropDownVisible && "is-reverse"]),
            onClick: _cache[1] || (_cache[1] = withModifiers(function($event) {
              return _ctx.toggleDropDownVisible();
            }, ["stop"]))
          }, null, 8, ["class"]))];
        }),
        _: 1
        /* STABLE */
      }, 8, ["model-value", "size", "placeholder", "readonly", "disabled", "display-only", "display-only-content", "class", "onFocus", "onBlur", "onUpdate:modelValue"])) : createCommentVNode("v-if", true), _ctx.state.multiple && !_ctx.state.isDisplayOnly && !_ctx.shape ? (openBlock(), createElementBlock(
        "div",
        {
          key: 1,
          ref: "tags-content",
          class: normalizeClass(["xm-cascader__tags", {
            "is-expand-content": _ctx.hoverExpand && !_ctx.state.isDisabled && (_ctx.state.inputHover || _ctx.state.dropDownVisible)
          }])
        },
        [_ctx.hoverExpand ? (openBlock(), createBlock(_component_xm_tag, {
          key: 0,
          class: normalizeClass(["xm-cascader__tags-collapse", {
            "is-hidden": _ctx.state.isHidden
          }]),
          type: "info",
          closable: false,
          size: _ctx.state.tagSize
        }, {
          default: withCtx(function() {
            return [createTextVNode(
              "+ " + toDisplayString(_ctx.state.collapseTagsLength),
              1
              /* TEXT */
            )];
          }),
          _: 1
          /* STABLE */
        }, 8, ["class", "size"])) : createCommentVNode("v-if", true), (openBlock(true), createElementBlock(
          Fragment,
          null,
          renderList(_ctx.state.presentTags, function(tag, index) {
            return openBlock(), createBlock(_component_xm_tag, {
              key: tag.key,
              type: "info",
              size: _ctx.state.tagSize,
              hit: tag.hitState,
              closable: tag.closable,
              "disable-transitions": "",
              onClose: function onClose($event) {
                return _ctx.deleteTag(index);
              },
              onMouseenter: _ctx.handleMouseenter,
              onMouseleave: _ctx.handleMouseleave
            }, {
              default: withCtx(function() {
                return [createElementVNode(
                  "span",
                  null,
                  toDisplayString(tag.text),
                  1
                  /* TEXT */
                )];
              }),
              _: 2
              /* DYNAMIC */
            }, 1032, ["size", "hit", "closable", "onClose", "onMouseenter", "onMouseleave"]);
          }),
          128
          /* KEYED_FRAGMENT */
        )), _ctx.filterable && !_ctx.state.isDisabled ? withDirectives((openBlock(), createElementBlock("input", {
          key: 1,
          "onUpdate:modelValue": _cache[2] || (_cache[2] = function($event) {
            return _ctx.state.inputValue = $event;
          }),
          type: "text",
          class: "xm-cascader__search-input",
          placeholder: _ctx.state.presentTags.length ? "" : _ctx.placeholder,
          onInput: _cache[3] || (_cache[3] = function(e) {
            return _ctx.handleInput(_ctx.state.inputValue, e);
          }),
          onClick: _cache[4] || (_cache[4] = withModifiers(function($event) {
            return _ctx.toggleDropDownVisible(true);
          }, ["stop"])),
          onKeydown: _cache[5] || (_cache[5] = withKeys(function() {
            return _ctx.handleDelete && _ctx.handleDelete.apply(_ctx, arguments);
          }, ["delete"]))
        }, null, 40, _hoisted_2)), [[vModelText, _ctx.state.inputValue, void 0, {
          trim: true
        }]]) : createCommentVNode("v-if", true)],
        2
        /* CLASS */
      )) : createCommentVNode("v-if", true)],
      512
      /* NEED_PATCH */
    ), createVNode(_component_xm_tooltip, {
      ref: "tooltip",
      modelValue: _ctx.state.tooltipVisible,
      "onUpdate:modelValue": _cache[6] || (_cache[6] = function($event) {
        return _ctx.state.tooltipVisible = $event;
      }),
      manual: true,
      effect: "light",
      content: _ctx.state.tooltipContent,
      placement: "top"
    }, null, 8, ["modelValue", "content"]), createVNode(Transition, {
      name: "xm-zoom-in-top",
      onAfterLeave: _ctx.handleDropdownLeave,
      persisted: ""
    }, {
      default: withCtx(function() {
        return [withDirectives(createElementVNode(
          "div",
          {
            ref: "popper",
            class: normalizeClass(["xm-popper", "xm-cascader-dropdown", "xm-cascader__dropdown", _ctx.popperClass, {
              "is-auto-size": _ctx.autoSize,
              "is-multiple": _ctx.state.multiple
            }]),
            onMousedown: _cache[9] || (_cache[9] = withModifiers(function() {
            }, ["stop"]))
          },
          [withDirectives(createVNode(_component_xm_cascader_panel, {
            ref: "panel",
            modelValue: _ctx.state.checkedValue,
            "onUpdate:modelValue": _cache[7] || (_cache[7] = function($event) {
              return _ctx.state.checkedValue = $event;
            }),
            options: _ctx.options,
            props: _ctx.state.config,
            border: false,
            "render-label": _ctx.slots.default,
            onExpandChange: _ctx.handleExpandChange,
            onClose: _cache[8] || (_cache[8] = function($event) {
              return _ctx.toggleDropDownVisible(false);
            })
          }, null, 8, ["modelValue", "options", "props", "render-label", "onExpandChange"]), [[vShow, !_ctx.state.filtering]]), _ctx.filterable ? withDirectives((openBlock(), createBlock(_component_xm_scrollbar, {
            key: 0,
            ref: "suggestionPanel",
            tag: "ul",
            class: "xm-cascader__suggestion-panel",
            "view-class": "xm-cascader__suggestion-list",
            onKeydown: _ctx.handleSuggestionKeyDown
          }, createSlots({
            default: withCtx(function() {
              return [!_ctx.state.suggestions.length ? renderSlot(_ctx.$slots, "empty", {
                key: 0
              }, function() {
                return [createElementVNode(
                  "li",
                  _hoisted_4,
                  toDisplayString(_ctx.t("ui.cascader.noMatch")),
                  1
                  /* TEXT */
                )];
              }) : createCommentVNode("v-if", true)];
            }),
            _: 2
            /* DYNAMIC */
          }, [_ctx.state.suggestions.length ? {
            name: "default",
            fn: withCtx(function() {
              return [(openBlock(true), createElementBlock(
                Fragment,
                null,
                renderList(_ctx.state.suggestions, function(item, index) {
                  return openBlock(), createElementBlock("li", {
                    key: item.uid,
                    class: normalizeClass(["xm-cascader__suggestion-item", item.checked && "is-checked"]),
                    tabindex: -1,
                    onClick: function onClick($event) {
                      return _ctx.handleSuggestionClick(index);
                    }
                  }, [renderSlot(_ctx.$slots, "filter", {
                    item: item.text
                  }, function() {
                    return [createTextVNode(
                      toDisplayString(item.text),
                      1
                      /* TEXT */
                    )];
                  }), item.checked ? (openBlock(), createBlock(_component_icon_yes, {
                    key: 0,
                    class: "icon-check"
                  })) : createCommentVNode("v-if", true)], 10, _hoisted_3);
                }),
                128
                /* KEYED_FRAGMENT */
              ))];
            }),
            key: "0"
          } : void 0]), 1032, ["onKeydown"])), [[vShow, _ctx.state.filtering]]) : createCommentVNode("v-if", true)],
          34
          /* CLASS, HYDRATE_EVENTS */
        ), [[vShow, _ctx.state.dropDownVisible]])];
      }),
      _: 3
      /* FORWARDED */
    }, 8, ["onAfterLeave"])],
    34
    /* CLASS, HYDRATE_EVENTS */
  )), [[_directive_clickoutside, function() {
    return _ctx.toggleDropDownVisible(false);
  }]]);
}
var pc = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
export {
  pc as default
};
